Updating NJS 3.x to 4.0.1
-------------------------

Further documentation can be found in njs/docs/

This NJS does not understand 3.x AJOs and so will not accept
AJOs from 3.x clients of 3.x NJSs.

If you are updating an existing installation you must clear all
jobs from the NJS (executing and finished).

If you are running with the Pallas Client you need to be using Java 1.4.

1) Either Install the V4 Gateway
   or     Stop the Gateway and install the V4 AJO jar file. Restart Gateway.

2) Stop the TSI and update the tsi_ls, Initialisation.pm, Endprocessing.pm
   and GetDirectory.pm files (keeping any local changes to these files e.g. to prevent
   zombie processes). The updated files can be found in njs/tsi_updates
   
   Restart TSI.

3) Stop the NJS.

4) Install the V4 NJS and AJO jar files.

5) Update the IDB (see NJSChanges4_x.x.x.pdf for the required and optional changes)
   Delete IMPORT, EXPORT, COPY_FILE sections, insert FILE_COPY.
   Modify LIST_DIRECTORY

6) Consider whether you want to use NJS registration. If so change the njs.properties
   file to allow this (Gateways must be a V4.0.0)

7) Remove all the files in the NJS state directory (configuration value njs.save_dir)
   THIS WILL DELETE ALL AJOS THAT WERE ON THE NJS

8) Restart the NJS

9) Use the njs_admin tool to delete all uspaces outcomes, and spool directories marked
   as orphaned (use njs_admin->ls to find these and njs_admin->remove
   to delete them)
   THIS WILL DELETE ALL DATA ASSOCIATED WITH ANY AJOS THAT WERE PREVIOUSLY ON THE NJS

GOTCHAS

1) The NJS checks that AJOs that it receives are intended for the NJS. It does this by
   checking that the Vsite name in the AJO is the same as the NJS's name. If an AJO
   is rejected for "not mutable" reasons you should check that the njs.properties entry 
   "njs.vsite_name" is the same as the name for the Vsite in the Gateway's configuration files.
